# encoding: utf-8

'''
@author: vmmhypervisor
'''


import itertools
import golib.sqlite as sql


def getAllPairMatrix(item_listlist):
    item_list_count = len(item_listlist)

    def getBaseRowList(idx):
        return [
            item_list[(idx) % len(item_list)]
            for item_list in item_listlist
        ]

    allpair_matrix = []

    for lhs_idx in range(item_list_count - 1):
        # 2要素間の組み合わせを網羅する
        for rhs_idx in range(lhs_idx + 1, item_list_count - 1):
            product = itertools.product(
                item_listlist[lhs_idx], item_listlist[rhs_idx])
            for pair_idx, pair in enumerate(product):
                work_list = getBaseRowList(
                    pair_idx + lhs_idx + rhs_idx)  # pair対象外は値を散らす
                work_list[lhs_idx] = pair[0]
                work_list[rhs_idx] = pair[1]

                allpair_matrix.append(work_list)

    table_name = "MEM"
    tmp_attr_list = [str(i) for i in range(item_list_count)]

    con = sql.connect_sqlite_db_mem()
    con.createTableWithDataEx(
        table_name, tmp_attr_list, allpair_matrix)
    result = con.execute_select(
        select="DISTINCT *", table=table_name)

    return result.fetchall()
